'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.startMouseEvent = startMouseEvent;

var _event = require('./event');

(0, _event.addHandler)('load', function (state) {
    window.addEventListener('focus', function () {
        return (0, _event.handle)(state, 'windowfocus');
    });
    window.addEventListener('blur', function () {
        return (0, _event.handle)(state, 'windowblur');
    });

    var resize = function resize(event) {
        return (0, _event.handle)(state, 'resize');
    };
    window.addEventListener('resize', resize);
    window.addEventListener('fullscreenchange', resize);

    document.addEventListener('visibilitychange', function () {
        if (document.hidden) {
            (0, _event.handle)(state, 'pagehide');
        } else {
            (0, _event.handle)(state, 'pageshow');
        }
    });
});

// Saving the event instance so repeated mouse inputs don't take up gc resources.
var mouseEvent = { x: 0, y: 0, buttons: 0 };

function startMouseEvent(state, eventName, component) {
    var skidEventName = arguments.length <= 3 || arguments[3] === undefined ? eventName : arguments[3];
    return (function () {
        component.addEventListener(eventName, function (event) {
            mouseEvent.x = event.clientX;
            mouseEvent.y = event.clientY;
            mouseEvent.buttons = event.buttons;
            (0, _event.handle)(state, skidEventName, mouseEvent);
        });
    })();
}

window.addEventListener('drop', function (event) {
    return event.preventDefault();
}, true);
window.addEventListener('dragover', function (event) {
    return event.preventDefault();
}, true);
//# sourceMappingURL=input.js.map
